"use strict";exports.__esModule=true;exports.collectPages=collectPages;exports.printTreeView=printTreeView;exports.getFileForPage=getFileForPage;exports.getSpecifiedPages=getSpecifiedPages;exports.getCacheIdentifier=getCacheIdentifier;exports.getPageInfo=getPageInfo;var _crypto=_interopRequireDefault(require("crypto"));var _findUp=_interopRequireDefault(require("find-up"));var _fs=_interopRequireDefault(require("fs"));var _path=_interopRequireDefault(require("path"));var _util=require("util");var _prettyBytes=_interopRequireDefault(require("../lib/pretty-bytes"));var _recursiveReaddir=require("../lib/recursive-readdir");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}const fsStat=(0,_util.promisify)(_fs.default.stat);const fsExists=(0,_util.promisify)(_fs.default.exists);const fsReadFile=(0,_util.promisify)(_fs.default.readFile);function collectPages(directory,pageExtensions){return(0,_recursiveReaddir.recursiveReadDir)(directory,new RegExp(`\\.(?:${pageExtensions.join('|')})$`));}function printTreeView(list,pageInfos){/*
    red for >250kb
    yellow for >100kb
    green for <100kb
  */const getSizeColor=size=>{if(size<100*1000)return'\x1b[32m';if(size<250*1000)return'\x1b[33m';return'\x1b[31m';};list.sort((a,b)=>a>b?1:-1).forEach((item,i)=>{const info=pageInfos.get(item);let numExternal;let numInternal;let serverSize;let clientSize;let isAmp;if(info){isAmp=info.ampOnly;serverSize=info.serverSize;clientSize=info.clientSize;if(info.chunks){const{chunks}=info;numExternal=chunks.external.size;numInternal=chunks.internal.size;}}const corner=i===0?list.length===1?'─':'┌':'├';console.log(` \x1b[90m${corner}\x1b[39m ${item}${isAmp?' (AMP)':''}`);if(typeof numExternal==='number'){console.log(` \x1b[90m| \x1b[39mPackages: ${numExternal} Local modules: ${numInternal}`);}let sizes=' \x1b[90m|';if(typeof serverSize==='number'){sizes+=getSizeColor(serverSize)+` Server size: ${(0,_prettyBytes.default)(serverSize)}`;}if(typeof clientSize==='number'){sizes+=getSizeColor(clientSize)+` Client size: ${(0,_prettyBytes.default)(clientSize)}`;}if(sizes)console.log(sizes);console.log(` \x1b[90m${i===list.length-1?'└':'|'}`);});console.log();}function flatten(arr){return arr.reduce((acc,val)=>acc.concat(val),[]);}function getPossibleFiles(pageExtensions,pages){const res=pages.map(page=>pageExtensions.map(e=>`${page}.${e}`).concat(pageExtensions.map(e=>`${_path.default.join(page,'index')}.${e}`)).concat(page));return flatten(res);}async function getFileForPage({page,pagesDirectory,pageExtensions}){const theFile=getPossibleFiles(pageExtensions,[_path.default.join(pagesDirectory,page)]).find(f=>_fs.default.existsSync(f)&&_fs.default.lstatSync(f).isFile());if(theFile){return _path.default.sep+_path.default.relative(pagesDirectory,theFile);}return theFile;}async function getSpecifiedPages(dir,pagesString,pageExtensions){const pagesDir=_path.default.join(dir,'pages');const reservedPages=['/_app','/_document','/_error'];const explodedPages=[...new Set([...pagesString.split(','),...reservedPages])].map(p=>{let resolvedPage;if(_path.default.isAbsolute(p)){resolvedPage=getPossibleFiles(pageExtensions,[_path.default.join(pagesDir,p),p]).find(f=>_fs.default.existsSync(f)&&_fs.default.lstatSync(f).isFile());}else{resolvedPage=getPossibleFiles(pageExtensions,[_path.default.join(pagesDir,p),_path.default.join(dir,p)]).find(f=>_fs.default.existsSync(f)&&_fs.default.lstatSync(f).isFile());}return{original:p,resolved:resolvedPage||null};});const missingPage=explodedPages.find(({original,resolved})=>!resolved&&!reservedPages.includes(original));if(missingPage){throw new Error(`Unable to identify page: ${missingPage.original}`);}const resolvedPagePaths=explodedPages.filter(page=>page.resolved).map(page=>'/'+_path.default.relative(pagesDir,page.resolved));return resolvedPagePaths.sort();}async function getCacheIdentifier({pagesDirectory,env={}}){let selectivePageBuildingCacheIdentifier='';const envObject=env?Object.keys(env).sort()// eslint-disable-next-line
.reduce((a,c)=>(a[c]=env[c],a),{}):{};selectivePageBuildingCacheIdentifier+=JSON.stringify(envObject);const pkgPath=await(0,_findUp.default)('package.json',{cwd:pagesDirectory});if(pkgPath){const yarnLock=_path.default.join(_path.default.dirname(pkgPath),'yarn.lock');const packageLock=_path.default.join(_path.default.dirname(pkgPath),'package-lock.json');if(await fsExists(yarnLock)){selectivePageBuildingCacheIdentifier+=await fsReadFile(yarnLock,'utf8');}else if(await fsExists(packageLock)){selectivePageBuildingCacheIdentifier+=await fsReadFile(packageLock,'utf8');}else{selectivePageBuildingCacheIdentifier+=JSON.stringify(require(pkgPath));}}return _crypto.default.createHash('sha1').update(selectivePageBuildingCacheIdentifier).digest('hex');}async function getPageInfo(page,distPath,buildId,dev,serverless){const info={};const staticPath=dev?'development':buildId;const clientBundle=_path.default.join(distPath,`static/${staticPath}/pages/`,`${page}.js`);const serverPath=serverless?_path.default.join(distPath,'serverless/pages'):_path.default.join(distPath,'server/static',staticPath,'pages');const serverBundle=_path.default.join(serverPath,`${page}.js`);info.clientBundle=clientBundle;if(!dev){try{info.serverSize=(await fsStat(serverBundle)).size;}catch(_){}try{info.clientSize=(await fsStat(clientBundle)).size;}catch(_){}}if(page.match(/(_app|_error|_document)/))return info;return info;}